/*
 * Void.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Void.h"
#include "../sax/FromXMLParserHelper.h"
#include "Object.h"
#include "UniqueObject.h"

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>

namespace alib {

Void::Void() {

}

ObjectBase* Void::clone() const {
	return new Void(*this);
}

ObjectBase* Void::plunder() && {
	return new Void(std::move(*this));
}

int Void::compare(const Void&) const {
	return 0;
}

void Void::operator>>(std::ostream& out) const {
	out << "(Void)";
}

Void::operator std::string () const {
	return "V";
}

Void Void::VOID = Void();

ObjectBase* Void::inc() && {
	return new UniqueObject(Object(std::move(*this)), primitive::Integer(0));
}

} /* namespace alib */

namespace alib {

void xmlApi < void >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
}

bool xmlApi < void >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < void >::xmlTagName ( ) {
	static std::string xmlTagName = "Void";

	return xmlTagName;
}

void xmlApi < void >::compose ( ext::deque < sax::Token > & output ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

alib::Void xmlApi < alib::Void >::parse ( ext::deque < sax::Token >::iterator & input ) {
	xmlApi < void >::parse ( input );
	return alib::Void ( );
}

bool xmlApi < alib::Void >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < alib::Void >::xmlTagName ( ) {
	return xmlApi < void >::xmlTagName ( );
}

void xmlApi < alib::Void >::compose ( ext::deque < sax::Token > & output, const alib::Void & ) {
	xmlApi < void >::compose ( output );
}

} /* namespace alib */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alib::Void > ( );

static auto xmlWrite = registration::XmlWriterRegister < alib::Object, alib::Void > ( );

static auto xmlReaded = registration::XmlReaderRegister < alib::Object, alib::Void > ( );

} /* namespace */
