#ifndef _CAST_REGISTRATION_HPP_
#define _CAST_REGISTRATION_HPP_

#include <core/castApi.hpp>
#include <abstraction/CastRegistry.hpp>

#include <registration/NormalizationRegistration.hpp>

namespace registration {

template < class To, class From >
class CastRegister {
public:
	CastRegister ( ) {
		alib::castApi::getCastPool < To > ( ).template add < From > ( );

		bool normalize = registration::NormalizationRegister < To > ( ).requireNormalization ( );
		abstraction::CastRegistry::registerCast < To, From > ( normalize );
	}

	CastRegister ( To ( * castFunction ) ( const From & ) ) {
		alib::castApi::getCastPool < To > ( ).template add < From > ( castFunction );

		bool normalize = registration::NormalizationRegister < To > ( ).requireNormalization ( );
		abstraction::CastRegistry::registerCastAlgorithm < To, From > ( castFunction, normalize );
	}
};

} /* namespace registration */

#endif // _CAST_REGISTRATION_HPP_
